<?php
/*
Plugin Name: Remove Revisions
Plugin URI: http://technologytales.com/
Description: Clear all revisions from database to reduce clutter
Version: 1.0
Author: John Hennessy
Author URI: http://technologytales.com/

License:

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA
*/

function remove_revisions(){

  	global $wpdb, $_POST;

  	echo "<div class=\"wrap\">\n";
  	echo "<h2>Remove Revisions</h2>\n";

  if($_POST["action"]){
  	
   $wpdb->query("DELETE FROM " . $wpdb->prefix . "posts where post_type='revision'");
   
   $count=$wpdb->get_var("SELECT count(*) as count FROM " .$wpdb->prefix ."posts where post_type='revision' ORDER BY ID");
   
   if ($count == 0) {
?>
  <br />Your revisions have been removed.<br />
<?php
   }
   else {
   	?>
   	<p>Your revisions have not been removed.</p>
<?php
   }
  } else {
?>
<?php 

	$count=$wpdb->get_var("SELECT count(*) as count FROM " .$wpdb->prefix ."posts where post_type='revision' ORDER BY ID");

	if ($count > 0) {
?>
  <p>The one reason why Wiki's place such a load on web servers is because of their revision tracking. Now that
  WordPress has added the same sort of functionality and it is by default, clearing out the revisions in the 
  database every so often is a good idea if you don't want to turn off the functionality. That's exactly what 
  this plugin does. So that you can look before you leap, here are your current revisons below.</p>
  <h3>Current Revisons</h3>
<?php
   	$sql = "SELECT * FROM " .$wpdb->prefix ."posts where post_type='revision' ORDER BY ID";
   	$posts = $wpdb->get_results($sql);

	foreach ($posts as $post) {
		echo "<p>$post->post_title ($post->guid)</p>";
	}
	?>
  <form action="<?php echo get_bloginfo('url');?>/wp-admin/edit.php?page=remove-revisons.php" method="post">
    <input type="hidden" name="action" value="go">
    <div class="submit"><input type="submit" value="Remove Revisions" style="font-weight:bold;float:left;"></div><br clear="all">
  </form>
  <?php
	}
	else {
		?>

  <p>The one reason why Wiki's place such a load on web servers is because of their revision tracking. Now that
  WordPress has added the same sort of functionality and it is by default, clearing out the revisions in the 
  database every so often is a good idea if you don't want to turn off the functionality. That's exactly what 
  this plugin does.</p>
  <p>However, you have no revisions so no action can be taken.</p>
  <?php
	}
  }

  print "</div>\n";
}

function add_remove_revisions_page() {
  if ( function_exists('add_management_page') ) {
    add_management_page('Remove Revisions', 'Remove Revisions', 8, basename(__FILE__), 'remove_revisions');
  }
}

add_action('admin_menu', 'add_remove_revisions_page');
?>